
Eina_Bool _efl_config_global_save(Eo *obj, void *pd, const char *profile);

EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_config_save, Eina_Bool, 0, EFL_FUNC_CALL(profile), const char *profile);

void _efl_config_global_profile_set(Eo *obj, void *pd, const char *profile);


static Eina_Error
__eolian_efl_config_global_profile_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   const char *cval;
   if (!eina_value_string_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_config_profile_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_config_profile_set, EFL_FUNC_CALL(profile), const char *profile);

const char *_efl_config_global_profile_get(const Eo *obj, void *pd);


static Eina_Value
__eolian_efl_config_global_profile_get_reflect(const Eo *obj)
{
   const char *val = efl_config_profile_get(obj);
   return eina_value_string_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_config_profile_get, const char *, NULL);

Eina_Iterator *_efl_config_global_profile_iterate(Eo *obj, void *pd, Eina_Bool hidden);

EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_config_profile_iterate, Eina_Iterator *, NULL, EFL_FUNC_CALL(hidden), Eina_Bool hidden);

Eina_Bool _efl_config_global_profile_exists(Eo *obj, void *pd, const char *profile);

EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_config_profile_exists, Eina_Bool, 0, EFL_FUNC_CALL(profile), const char *profile);

Eina_Stringshare *_efl_config_global_profile_dir_get(Eo *obj, void *pd, const char *profile, Eina_Bool is_user);

EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_config_profile_dir_get, Eina_Stringshare *, NULL, EFL_FUNC_CALL(profile, is_user), const char *profile, Eina_Bool is_user);

void _efl_config_global_profile_derived_add(Eo *obj, void *pd, const char *profile, const char *options);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_config_profile_derived_add, EFL_FUNC_CALL(profile, options), const char *profile, const char *options);

void _efl_config_global_profile_derived_del(Eo *obj, void *pd, const char *profile);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_config_profile_derived_del, EFL_FUNC_CALL(profile), const char *profile);

Eina_Bool _efl_config_global_efl_config_config_set(Eo *obj, void *pd, const char *name, const Eina_Value *value);


Eina_Value *_efl_config_global_efl_config_config_get(const Eo *obj, void *pd, const char *name);


static Eina_Bool
_efl_config_global_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_CONFIG_GLOBAL_EXTRA_OPS
#define EFL_CONFIG_GLOBAL_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_config_save, _efl_config_global_save),
      EFL_OBJECT_OP_FUNC(efl_config_profile_set, _efl_config_global_profile_set),
      EFL_OBJECT_OP_FUNC(efl_config_profile_get, _efl_config_global_profile_get),
      EFL_OBJECT_OP_FUNC(efl_config_profile_iterate, _efl_config_global_profile_iterate),
      EFL_OBJECT_OP_FUNC(efl_config_profile_exists, _efl_config_global_profile_exists),
      EFL_OBJECT_OP_FUNC(efl_config_profile_dir_get, _efl_config_global_profile_dir_get),
      EFL_OBJECT_OP_FUNC(efl_config_profile_derived_add, _efl_config_global_profile_derived_add),
      EFL_OBJECT_OP_FUNC(efl_config_profile_derived_del, _efl_config_global_profile_derived_del),
      EFL_OBJECT_OP_FUNC(efl_config_set, _efl_config_global_efl_config_config_set),
      EFL_OBJECT_OP_FUNC(efl_config_get, _efl_config_global_efl_config_config_get),
      EFL_CONFIG_GLOBAL_EXTRA_OPS
   );
   opsp = &ops;

   static const Efl_Object_Property_Reflection refl_table[] = {
      {"profile", __eolian_efl_config_global_profile_set_reflect, __eolian_efl_config_global_profile_get_reflect},
   };
   static const Efl_Object_Property_Reflection_Ops rops = {
      refl_table, EINA_C_ARRAY_LENGTH(refl_table)
   };
   ropsp = &rops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_config_global_class_desc = {
   EO_VERSION,
   "Efl.Config_Global",
   EFL_CLASS_TYPE_REGULAR,
   0,
   _efl_config_global_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_config_global_class_get, &_efl_config_global_class_desc, EFL_OBJECT_CLASS, EFL_CONFIG_INTERFACE, NULL);
